#property copyright "fxdaytrader, http://ForexBaron.net"
#property link      "http://ForexBaron.net/"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Yellow
#property indicator_color2 Aqua
#property indicator_level1 25
#property indicator_level2 -25
#property indicator_levelcolor SteelBlue 
#define PREFIX "MultiInd"

extern double AddValue        = 0.0; //-7.8592;
extern string is0             = "indicator settings:";
extern string is1             = "RSI:";                         
extern int    rsiperiod       = 13;
extern int    rsiprice        = 0;
extern string is2             = "STOCHASTIC:";
extern int    StochK          = 8;
extern int    StochD          = 3;
extern int    StochSlowing    = 3;
extern int    StochMethod     = 1;
extern string spfhi           = "0:Low/High, 1:Close/Close";
extern int    StochPriceField = 1;
extern string is3             = "CCI:";
extern int    cciperiod       = 21;
extern int    cciprice        = 0;
extern string is4             = "MOMENTUM:";
extern int    momperiod       = 13;
extern int    momprice        = 0;
extern string is5             = "MONEY FLOW INDEX:";
extern int    mfiperiod       = 13;
extern string is6             = "DEMARKER:";
extern int    demarkerperiod  = 14;
extern int    Level           = 25;
extern int    Levela           = 25;
extern bool   MA_filter       = false;
extern int    Period_MA       = 14;
extern int    Mode_MA         = 0;
extern bool   Alerts          = true;
extern bool   AlertSound      = true;
extern bool   Arrow           = true;
extern int    ArrowSize       = 1;
extern int    SIGNAL_BAR      = 1;



double Buf1[],Buf2[], Buf3[],Buf4[], trend[];

//=================================================================
int init() {
   IndicatorBuffers(3);
   SetIndexStyle (0, DRAW_LINE);
   SetIndexBuffer(0, Buf1);
   SetIndexLabel (0, "Indicatorline");
   
   SetIndexStyle (1,DRAW_LINE);
   SetIndexBuffer(1,Buf2);
   SetIndexLabel (1, "MA");
   SetIndexBuffer(2,trend);
   
   IndicatorShortName("MultiIndicator & AAA");
   return (0);
}
//================================================================== 
  int deinit()                            //    
{                                           
   for (int i = ObjectsTotal()-1; i >= 0; i--)   
   if (StringSubstr(ObjectName(i), 0, StringLen(PREFIX)) == PREFIX)
       ObjectDelete(ObjectName(i));
   return(0);  
}
//==================================================================
int start() {
   double RSI;
   double CCI;
   double Mom;
   double MFI;
   double DeM;
   double Stoch_m;
   double Stoch_s;
   int counted_bars = IndicatorCounted();
   if (counted_bars > 0) counted_bars--;
   int limit = Bars - counted_bars;
   for (int i = 0; i < limit; i++) {
      RSI = iRSI(Symbol(), 0, rsiperiod, rsiprice, i);
      CCI = iCCI(Symbol(), 0, cciperiod, cciprice, i);
      Mom = iMomentum(Symbol(), 0, momperiod, momprice, i);
      MFI = iMFI(Symbol(), 0, mfiperiod, i);
      DeM = iDeMarker(Symbol(), 0, demarkerperiod, i);
      Stoch_m = iStochastic(Symbol(), 0, StochK, StochD, StochSlowing, StochMethod, StochPriceField, MODE_MAIN, i);
      Stoch_s = iStochastic(Symbol(), 0, StochK, StochD, StochSlowing, StochMethod, StochPriceField, MODE_SIGNAL, i);
      if (RSI == 0.0) RSI = 0.00000001;
      if (CCI == 0.0) CCI = 0.00000001;
      if (Mom == 0.0) Mom = 0.00000001;
      if (MFI == 0.0) MFI = 0.00000001;
      if (DeM == 0.0) DeM = 0.00000001;
      if (Stoch_m == 0.0) Stoch_m = 0.00000001;
      if (Stoch_s == 0.0) Stoch_s = 0.00000001;
      Buf1[i] = 100.0 * ((RSI + (Stoch_m + Stoch_s) / 3.0 + CCI / 5.0 +  MFI + 100.0 * DeM) / 5.0 * (1 / Mom) - 0.31415926) + AddValue;
      }
//====================================================================
   for(int j=limit; j>=0; j--)
   {
      trend[j] = trend[j+1];
     {
    if(MA_filter)
       {
       Buf2[j]= iMAOnArray(Buf1,0,Period_MA,0,Mode_MA,j);   
       }
     }  
     {
     if(Arrow)
      {
      int s=1;
     //      if(Buf1[j+SIGNAL_BAR+1] > -(Level)  && Buf1[j+SIGNAL_BAR] < -(Level))  manageArr(j+1,Yellow, 234,true );
         if(trend[j]!=-1 && Buf1[j+SIGNAL_BAR+1] > -(Level)  && Buf1[j+SIGNAL_BAR] < -(Levela))  { trend[j] =-1; manageArr(j+1,clrOrange,   234,true ); }
         if(trend[j]!= 1 && Buf1[j+SIGNAL_BAR+1] <   Level   && Buf1[j+SIGNAL_BAR] >   Level  )  { trend[j] = 1; manageArr(j+1,clrLimeGreen,233,false); }
    }}}
//==================================================================== 
    static int PrevSignal = 0, PrevTime = 0;
	  if(SIGNAL_BAR > 0 && Time[0] <= PrevTime) 
	  return(0);

	  PrevTime = Time[0];
//--------------------------------------------------------------------	      
 if(Alerts)
  {
   if(PrevSignal <= 0)
	 {
	 if(Buf1[SIGNAL_BAR+1] > -(Level)  && Buf1[SIGNAL_BAR] < -(Level))
	   {     
	   Alert(WindowExpertName() +"  (", Symbol(), ", ", Period(), ")  -  SELL!!!");
	   }
   if(PrevSignal <= 0)
	 {
	 if(Buf1[SIGNAL_BAR+1] < Level  && Buf1[SIGNAL_BAR] > Level)
	   {
		Alert(WindowExpertName() +"  (", Symbol(), ", ", Period(), ")  -  BUY!!!");
   }}}}
//====================================================================
   if(AlertSound)
  {
   if(PrevSignal <= 0)
	 {
	 if(Buf1[SIGNAL_BAR+1] > -(Level)  && Buf1[SIGNAL_BAR] < -(Level))
	   {     
	   PlaySound("stops.wav");
	   }
   if(PrevSignal <= 0)
	 {
	 if(Buf1[SIGNAL_BAR+1] < Level  && Buf1[SIGNAL_BAR] > Level)
	   {
		PlaySound("stops.wav");
   }}}}   
//==================================================================== 
   WindowRedraw();   
   return (0);
}
//====================================================================
void manageArr(int j, color clr, int theCode, bool up)   
{
   string objName = PREFIX + Time[j];
   double gap  = 3.0*iATR(NULL,0,20,j)/4.0;
   
   ObjectCreate(objName, OBJ_ARROW,0,Time[j],0);
   ObjectSet   (objName, OBJPROP_COLOR, clr);  
   ObjectSet   (objName, OBJPROP_ARROWCODE,theCode);
   ObjectSet   (objName, OBJPROP_WIDTH,ArrowSize);  
  if (up)
      ObjectSet(objName,OBJPROP_PRICE1,High[j]+gap);
     else  
      ObjectSet(objName,OBJPROP_PRICE1,Low[j] -gap);
}
//===================================================================